class SiGLObject(object):
    def __init__(self, *args, **kw):
        self.__dict__.update(kw)
        self._args = args

    def __repr__(self):
        return "<%s object as 0x%s>" % (self.__class__.__name__, id(self))

class MixIn(object):
    def __init__(self):
        """
        Set default variables in here.
        """
        pass
        
def Mix(A,B):
    """
    Mixes a normal class, and a MixIn style class into one class.
    A MixIn style class has an __init__ with no arguments or keywords.
    """
    class C(A,B):
        def __init__(self, *args, **kw):
            A.__init__(self, *args, **kw)
            B.__init__(self)
            pass
    return C
        