"""
This modules translates keys into controller events.
Modify the keymap dict to add or change keys.
Requires eventnet.
"""

import eventnet.driver
from pygame.locals import *

keymap = {97:'KEY_LEFT',119:"KEY_UP",100:"KEY_RIGHT",115:"KEY_DOWN",32:"KEY_FIRE",27:"KEY_QUIT"}
    


def keydown(event):
    try:
        eventnet.driver.post(keymap[event.key] + "_DOWN")
    except KeyError:
        pass

def keyup(event):
    try:
        eventnet.driver.post(keymap[event.key] + "_UP")
    except KeyError:
        pass

ku = None
kd = None
def enable():
    global kd
    global ku

    kd = eventnet.driver.handle(KEYDOWN)(keydown)        
    ku = eventnet.driver.handle(KEYUP)(keyup)

def disable():
    kd.kill()
    ku.kill()