from OpenGL.GL import *

import texture
import draw
from vector import Vector

import Image, ImageDraw, ImageFont, ImageOps


class StringPack(object):
    def __init__(self, font_filename="ARIAL.TTF", size=32, foreground=(1,1,1,1), background=(0,0,0,0)):
        self.pack = texture.TexturePack()
        
    def add(self, text, font_filename="ARIAL.TTF", size=32, foreground=(1,1,1,1), background=(0,0,0,0)):
        foreground = Vector(foreground)
        background = Vector(background)
        foreground = (foreground * 255.0).int()
        background =(background * 255.0).int()

        self.pack = texture.TexturePack()
        self.font = ImageFont.truetype(font_filename, size)
        self.background = background
        self.foreground = foreground
        
        t = Image.new('RGBA',self.font.getsize(text), self.background)
        image = ImageDraw.Draw(t)
        image.text((0,0),text, font=self.font, fill=self.foreground)
        tex = self.pack.add(t)
        self.pack.build()
        return draw.Image(tex)




def render(text, font_filename="ARIAL.TTF", size=32, foreground=(1,1,1,1), background=(0,0,0,0)):
    foreground = Vector(foreground)
    background = Vector(background)
    foreground = (foreground * 255.0).int()
    background =(background * 255.0).int()
    font = ImageFont.truetype(font_filename, size)

    t = Image.new('RGBA',font.getsize(text), background)
    image = ImageDraw.Draw(t)
    image.text((0,0),text, font=font, fill=foreground)

    return t



"""
class Writer(object):
    def __init__(self, font_filename="ARIAL.TTF", size=32, foreground=(1,1,1,1), background=(0,0,0,0)):
        foreground = Vector(foreground)
        background = Vector(background)
        foreground = (foreground * 255.0).int()
        background =(background * 255.0).int()
        font = ImageFont.truetype(font_filename, size)

        self.pack = SiGL.texture.TexturePack()
        self.alphabet = {}

        for c in range(255):
            t = Image.new('RGBA',Vector(font.getsize(chr(c)))+(1,0), background)
            image = ImageDraw.Draw(t)
            image.text((0,0),chr(c), font=font, fill=foreground)
            self.alphabet[chr(c)] = self.pack.add(t)

        self.pack.build()

    def write(self, text):
        x = 0.0
        for c in text:
            t = SiGL.draw.Image(self.alphabet[c])
            SiGL.display.get_screen().blit(t, (x,0))
            print c, x, t.n_size[0]
            x += t.n_size[0]
        print "-" * 10

"""
